#!/bin/sh
#   use -d for direct delete langs that are not in source codes
#   use -e for check only english lang file
#   langCheck.sh script for langs test
arg="$1"
argv="$2"

check (){
  searchTerm="id=\"$1\""
  found=$(grep $searchTerm $entry | wc -l)
  if [ "$found" -eq 0 ];
  then
    missing+=("$1")
    echo Missing: "$1"
  else
    echo $searchTerm >> temporary
  fi
}

#get all files with LocalizedString
IFS=$'\n'
lines=($(grep -rn ../../../.. -e "GetResourceText(" -e "LocalizedString(" -e "GetText(" | grep -v "GetText()" | grep -v "../../../../Sources/WinUWP" | grep -v "../../../../Sources/iOS/SygicNaviNativeUITests" | grep -v "../../../../Sources/iOS/SygicNaviNativeTests" | grep -v "../../../../Sources/Application/Projects/iOS/langCheck.sh" | grep -v "../../../../Sources/iOS/3rdParty" | grep -v "../../../../Sources/Android" | grep -v "../../../../Sources/Application/Source/Base/Layouts" | grep -v "../../../../Sources/Application/Source/Extra/Layouts" | grep -v "../../../../Sources/Application/Source/GPSSettings/Layouts" | grep -v "../../../../Sources/Application/Source/Main/Layouts" | grep -v "../../../../Sources/Application/Source/Online/Friends/Layouts" | grep -v "../../../../Sources/Application/Source/Online/LocalSearch/Layouts" | grep -v "../../../../Sources/Application/Source/Online/Migration/Layouts" | grep -v "../../../../Sources/Application/Source/Online/Photo/Layouts" | grep -v "../../../../Sources/Application/Source/Online/Store/Layouts" | grep -v "../../../../Sources/Application/Source/Online/VoiceDownload/Layouts" | grep -v "../../../../Sources/Application/Source/POI/Layouts" | grep -v "../../../../Sources/Application/Source/Preferences/Layouts" | grep -v "../../../../Sources/Application/Source/Route/Layouts" | grep -v "../../../../Sources/Application/Source/Search/Layouts" | grep -v "../../../../Sources/Application/Source/Travelbook/Layouts" | grep -v "../../../../Sources/Editor" | grep -v "../../../../Sources/Library/Source/Dialogs" | grep -v "../../../../Sources/Library/Source/Controls" | grep -v "../../../../Sources/Application/Source/Online/Friends/PhoneBook/Layouts" | grep -v "../../../../Sources/Application/Source/Route/Controls" | grep -v "../../../../Sources/Application/Source/Search/Controls" | grep -v "../../../../Sources/iOS/ExtPhotoNavi" | grep -v "../../../../Sources/Application/Source/SubMenu" | grep -v "../../../../Sources/Application/Source/POI/Controls" | grep -v "../../../../Sources/Application/Source/GPSSettings/Controls" | grep -v "../../../../Sources/Application/Source/GPSSettings/Controls" | grep -v "../../../../Sources/Application/Source/Extra/Controls" | grep -v "../../../../Sources/Application/Projects/iOS/SygicNavi.xcodeproj"))


#get all lang IDs
IDs=()
for ((i=0; i<${#lines[@]}; i++))
do
  ID=$(echo ${lines[$i]} |  sed -e 's/.*LocalizedString(\(.*\)"[ ]*).*/\1/g' -e 's/.*GetResourceText(\(.*\)"[ ]*).*/\1/g' -e 's/.*GetText(\(.*\)"[ ]*).*/\1/g')
  IDs+=($ID)
done

#keys for widget and photonavi
keys=($(cat ../../../../Sources/iOS/ExtPhotoNavi/Resources/keys.strings | sed -e 's/\(.*\)" = "";/\1/g'))
for ID in ${keys[@]}
do
  IDs+=($ID)
done
keys=($(cat ../../../../Sources/iOS/Widget/Resources/keys.strings | sed -e 's/\(.*\)" = "";/\1/g'))
for ID in ${keys[@]}
do
  IDs+=($ID)
done

#search IDs in lang files
for entry in "../../../../res/skin/langs_ios"/*
do
  if [[ $arg != "-e" ]] || [[ "$entry" == "../../../../res/skin/langs_ios/english.lang" ]];
  then
    checked="0"
    check="0"
    echo " "
    echo $entry
    missing=()
    for ID in ${IDs[@]}
    do
      #All IDs starting with "
      if [ "${ID:0:1}" = "\"" ] || [ "${ID:1:1}" = "\"" ];
      then
        IFS='"'
        tID=($ID)
        unset IFS
        t=${tID[1]}
        if [ "${t:0:1}" != "%" ]
        then
          check ${tID[1]}
        fi
      else
        #All IDs that contain condition ? true : false
        if [[ $ID = *"?"* ]];
        then
          IFS='"'
          tID=($ID)
          unset IFS
          t=${tID[1]}
          if [ "${t:0:1}" != "%" ]
          then
            check ${tID[1]}
          fi
          t=${tID[3]}
          if [ "${t:0:1}" != "%" ]
          then
            check ${tID[3]}
          fi
        else
          if [[ $ID = *"sc.ToChars(_T(\""* ]]
          then
            IFS='"'
            tID=($ID)
            unset IFS
            check ${tID[1]}
          else
            #All IDs that does contain methods and constants
            found=$(echo $ID | grep "NSString+Sygic.mm\|NSString+Sygic.h:3:\|RupiCity.cpp\|RupiElement.cpp\|RupiElement.h\|MotionXUnlockButton.mm:12:\|RouteCamCell.mm:17:\|SearchFieldDataProvider.mm:269:\|SearchAttribute.mm:104:\|SearchPositions.mm:261:\|SearchDataProvider.mm\|MeccaFinderData.mm:\|MeccaFinderMethodController.mm:\|MeccaFinderMethodData.mm:\|TravelBookViewController.mm:263:\|SharingStringProvider.mm:51:\|SharingStringProvider.mm:54:\|SettingsFuelTypeData.mm:26:\|SettCloudServiceViewController.mm:114:\|ApplicationWndNativeOnline.cpp:334:\|SettAboutData.mm\|SettInfoBarValuesData.mm:12:\|UIAlert.mm:146:\|ApplicationWndNative.cpp:417:\|SettSygicPoiCategoriesData.mm:40:\|SettPoiGroupsData.mm:99\|NearbyPoiGroupView.mm\|NearbyPoiGroupTableViewCell.mm:27:\|StoreHandler.mm:184:\|iOSApp.cpp:89:\|QuickSearch.mm\|ApplicationWndNativeContext.cpp:306:\|PoiExtensionsView.mm:224:\|PoiExtensionsView.mm:222:\|QuickSearchTableViewCell.mm:147:\|QuickSearchTableViewCell.mm:145:\|ApplicationWndFind.cpp\|ApplicationWndUtils.cpp:605:\|ApplicationWndBase.cpp:869:\|Wnd.h:312:\|Resources.cpp\|Language.h:25:\|XmlEval.cpp:55:\|3DStatic.cpp:487:\|ItemManager.cpp:259:\|Conversions.cpp:450:\|TrafficInterface.cpp:567:\|TrafficInterface.cpp:564:\|JunctionItem.cpp\|ExpressionParser.cpp\|Expression.cpp\|Expression.h\|StreetPartSearchState.cpp:130:\|ExpressionSearchState.cpp:99:\|CountrySearchState.cpp\|LocalStreetExprSearchState.cpp\|LocalMapStreetExprSearchState.cpp\|ItemTypesSearchState.cpp\|CityItemSearchState.cpp:258:\ExprResultPairs.cpp\|SearchSDK.cpp\|SearchMgr.cpp\|Router.cpp:1120:\|Traffic.cpp\|CityItemSearchState.cpp:258:\|ExprResultPairs.cpp\|NTOverlayRoute.cpp\|NTOverlayEdit.cpp\|UINotifyItems.cpp\|UIInfoBox.cpp\|Direction.cpp\|IManager.cpp\|PoiProviderRupi.h:287:\|PoiProviderRadars.cpp:184:\|3DMapCollectionCountries.cpp\|ExtensionManager.cpp\|ExtensionManager.h\|InstallProcess.cpp\|CityCenterSel.cpp:35:\|Temp.h:118:\|ApplicationWndBaseUtils.cpp:1360:\|ApplicationWndUtils.cpp\|ApplicationWndBase.cpp:872:\|WndProc.cpp:769:\|3DStatic.cpp" | wc -l)
            if [ "$found" -eq 0 ];
            then
              echo Check $ID
              check="1"
            else
              if [ $checked -eq 0 ];
              then
                check store.unlock
                check kmh_
                check prayerTime.fajr
                check prayerTime.sunrise
                check prayerTime.dhuhr
                check prayerTime.asr
                check prayerTime.sunset
                check prayerTime.maghrib
                check prayerTime.isha
                check value.height.uphill
                check value.height.downhill
                check mail.openLink
                check mail.openLinkAndroid
                check hierarchy.poitype.petrol
                check hierarchy.poitype.diesel
                check hierarchy.poitype.lpgAvailable
                check hierarchy.poitype.cng
                check lb.sett.group.Dropbox
                check lb.sett.group.Off
                check lb.sett.group.IOS
                check settings.about.build
                check settings.about.deviceCode
                check settings.about.deviceName
                check settings.about.enterprise
                check settings.about.glRenderer
                check settings.about.glVendor
                check settings.about.glVersion
                check settings.about.mapVersion
                check settings.about.product
                check settings.about.ram
                check settings.about.resolution
                check settings.about.speedcamslastupdate
                check settings.about.tmcVendor
                check settings.about.update
                check settings.about.version
                check settings.infobaritems.eta
                check settings.infobaritems.etaonly
                check settings.infobaritems.remTime
                check settings.infobaritems.speed
                check settings.infobaritems.elevation
                check settings.infobaritems.remDistance
                check settings.infobaritems.time
                check settings.infobaritems.signal
                check settings.infobaritems.routeLength
                check settings.infobaritems.fromStart
                check settings.infobaritems.none
                check alert.noMailAccount.title
                check alert.noMailAccount.text
                check store.product.error
                check native.warning.alert
                check native.download.error
                check mainMenu.info
                check message.customScheme.outofmap
                check native.plugin.cantNavi
                check shop.install.error
                check routecompute.error.destequal.title
                check routecompute.error.destequal.message
                check native.warning.info
                check shop.error.notEnoughSpace
                check message.activate.connectionNotAvailable
                check native.download.onemap
                check message.custompoi.importSuccess
                check message.custompoi.importFailed
                check _grp.Tourism
                check _grp.Food_and_Drink
                check _grp.Accomodation
                check _grp.Parking
                check _grp.Petrol_Station
                check _grp.Transportation
                check _grp.BankATM
                check _grp.Shopping
                check _grp.Vehicle_Services
                check _grp.Social_Life
                check _grp.Services_and_Education
                check _grp.Sport
                check _grp.Guides
                check _grp.Emergency
                check group.extentions
                check group.customPois
                check group.localSearch
                check group.friends
                check group.photos
                check group.fourSquare
                check _poi.TrafficLights
                check _poi.Wikipedia
                check _poi.Winery
                check _poi.Rent_a_Car_Facility
                check _poi.Tourist_Information_Office
                check _poi.Museum
                check _poi.Theatre
                check _poi.Cultural_Centre
                check _poi.Sports_Centre
                check _poi.Hospital_Polyclinic
                check _poi.Police_Station
                check _poi.City_Hall
                check _poi.Post_Office
                check _poi.First_Aid_Post
                check _poi.Pharmacy
                check _poi.Departement_Store
                check _poi.Bank
                check _poi.Travel_Agency
                check _poi.Public_Phone
                check _poi.Warehouse
                check _poi.Ski_Lift_Station
                check _poi.Zoo
                check _poi.Scenic_Panoramic_View
                check _poi.Transport_Company
                check _poi.Casino
                check _poi.Cinema
                check _poi.Cargo_Centre
                check _poi.Car_Shipping_Terminal
                check _poi.Camping_Ground
                check _poi.Caravan_Site
                check _poi.Coach_and_Lorry_Parking
                check _poi.Community_Centre
                check _poi.Customs
                check _poi.Embassy
                check _poi.Frontier_Crossing
                check _poi.Motoring_Organization_Office
                check _poi.Recreation_Facility
                check _poi.Road_Side_Diner
                check _poi.School
                check _poi.Shopping_Centre
                check _poi.Stadium
                check _poi.Toll
                check _poi.College_University
                check _poi.Business_Facility
                check _poi.Airport
                check _poi.Bus_Station
                check _poi.Exhibition_Centre
                check _poi.Kindergarten
                check _poi.Emergency_Call_Station
                check _poi.Emergency_Medical_Service
                check _poi.Fire_Brigade
                check _poi.Freeport
                check _poi.Company
                check _poi.ATM
                check _poi.Hippodrome
                check _poi.Beach
                check _poi.Restaurant_Area
                check _poi.Ice_Skating_Rink
                check _poi.Courthouse
                check _poi.Mountain_Peak
                check _poi.Opera
                check _poi.Concert_Hall
                check _poi.Bovag_Garage
                check _poi.Tennis_Court
                check _poi.Skating_Rink
                check _poi.Water_Sport
                check _poi.Music_Centre
                check _poi.Doctor
                check _poi.Dentist
                check _poi.Veterinarian
                check _poi.Cafe_Pub
                check _poi.Convention_Centre
                check _poi.Leisure_Centre
                check _poi.Nightlife
                check _poi.Yacht_Basin
                check _poi.Condominium
                check _poi.Commercial_Building
                check _poi.Industrial_Building
                check _poi.Natives_Reservation
                check _poi.Cemetery
                check _poi.General
                check _poi.Breakdown_Service
                check _poi.Vehicle_Equipment_Provider
                check _poi.Entertainment
                check _poi.Abbey
                check _poi.Amusement_Park
                check _poi.Arts_Centre
                check _poi.Building_Footprint
                check _poi.Castle
                check _poi.Church
                check _poi.Factory_Ground_Philips
                check _poi.Fortress
                check _poi.Golf_Course
                check _poi.Holiday_Area
                check _poi.Library
                check _poi.Lighthouse
                check _poi.Military_Cemetery
                check _poi.Monastery
                check _poi.Monument
                check _poi.Natural_Reserve
                check _poi.Prison
                check _poi.Rocks
                check _poi.Sports_Hall
                check _poi.State_Police_Office
                check _poi.Walking_Area
                check _poi.Water_Mill
                check _poi.Windmill
                check _poi.Rent_a_Car_Parking
                check _poi.Car_Racetrack
                check _poi.Mountain_Pass
                check _poi.Swimming_Pool
                check _poi.Government_Office
                check _poi.Agricultural_Industry
                check _poi.Construction
                check _poi.Factories
                check _poi.Media
                check _poi.Medical_Material
                check _poi.Personal_Services
                check _poi.Professionals
                check _poi.Real_Estate
                check _poi.Services
                check _poi.Border_Point
                check _poi.Hair_And_Beauty
                check _poi.Groceries
                check _poi.Port
                check _poi.Exchange
                check _poi.Money_Transfer
                check _poi.Pastry_and_Sweets
                check _poi.Archeology
                check _poi.Ecotourism_Sites
                check _poi.Hunting_Shop
                check _poi.Kids_Place
                check _poi.Mobile_Shop
                check _poi.Mosque
                check _poi.Squares
                check _poi.Local_Names
                check _poi.Parking_Garage
                check _poi.Place_of_Worship
                check _poi.Ferry_Terminal
                check _poi.Airline_Access
                check _poi.Open_Parking_Area
                check _poi.Important_Tourist_Attraction
                check _poi.Railway_Station
                check _poi.Rest_Area
                check _poi.Shop
                check _poi.Park_and_Recreation_Area
                check _poi.Forest_Area
                check _poi.Military_Installation
                check _poi.Public_Transport_Stop
                check _poi.Park_And_Ride
                check _poi.Car_Repair_Facility
                check _poi.Petrol_Station
                check _poi.Hotel_or_Motel
                check _poi.Restaurant
                check _poi.Cash_Dispenser
                check _poi.Car_Dealer
                check _poi.Food
                check _poi.Speed_Cameras
                check _poi.Supermarket
                check _poi.Car_Services
                check _poi.Accessories/Furniture
                check _poi.Books_Cards
                check _poi.Childrens_Fashion
                check _poi.Children_Toys
                check _poi.Cosmetics_Perfumes
                check _poi.Electronics_Mobiles
                check _poi.Fashion_Mixed
                check _poi.Fashion_Accessories
                check _poi.Traditional_Fashion
                check _poi.Gifts_Antiques
                check _poi.Jewellery_Watches
                check _poi.Ladies_Fashion
                check _poi.Lifestyle_Fitness
                check _poi.Men\'s_Fashion
                check _poi.Opticians_Sunglasses
                check _poi.Shoes_Bags
                check _poi.Sports
                check _poi.Metro
                check _poi.Chevrolet_car_dealer
                check _poi.Chevrolet_car_repair
                check shop.unknownBuyAction
                check shop.smsPurchase.error
                check shop.purchase
                check shop.purchaseexpired
                check shop.purchaseVerification.failed
                check shop.inappPurchase.error
                check shop.inappPurchase.failed
                check shop.webPurchase.error
                check shop.inappPayment.failed
                check shop.Webpurchase.redirection
                check shop.retryConnect
                check shop.uninstallerror
                check shop.installing
                check shop.noitemsretry
                check shop.retryInit
                check shop.product.error
                check shop.finished.reload
                check store.price
                check store.productStatus.subscribed
                check store.productStatus.activated
                check store.uninstall
                check store.update
                check store.manage
                check store.install
                check store.nothingRestored
                check store.products.listBox
                check store.main.frame.static
                check store.preview
                check store.restoreFailed
                check store.validUntil
                check store.completeRestoreWait
                check store.nothingRestored
                check store.noproductcode
                check store.free
                check store.size
                check store.languages
                check store.version
                check store.installed
                check store.search.length.message
                check store.support.subject
                check store.unlock
                check store.trial.over
                check store.trial.over.dashboard
                check store.selectRegionTitle
                check store.trial.over.paid
                check store.activated
                check prayerMethods.jafari
                check prayerMethods.karachi
                check prayerMethods.isna
                check prayerMethods.mwl
                check prayerMethods.makkah
                check prayerMethods.egypt
                check message.incommingCallNotify
                check button.yes
                check messageBox.ok
                check message.roaming
                check message.connect
                check message.askalways
                check message.tryconnect
                check message.avoid.ferries
                check messageBox.noYes
                check message.avoid.motorway.unable
                check messageBox.ok
                check message.avoid.unpavedRoads
                check message.avoid.unpavedRoads.unable
                check message.avoid.motorway
                check message.avoid.tollRoads
                check message.avoid.tollRoads.unable
                check message.route.unable
                check message.truckUnreachableArea
                check message.customScheme.noAddress
                check message.customScheme.outofmap
                check native.poidetail.locationNotFound
                check native.homeNotSet
                check native.workNotSet
                check km_
                check day.1
                check day.2
                check day.3
                check day.4
                check day.5
                check day.6
                check day.7
                check bmp.TMCTrafficProblem
                check bmp.TMCSlowTraffic
                check bmp.TMCSlowTraffic
                check bmp.TMCSlowTraffic
                check bmp.TMCStationaryTraffic
                check bmp.TMCCongestion
                check bmp.TMCStationaryTraffic
                check bmp.TrafficSlow
                check bmp.TrafficSlow
                check bmp.TrafficMedium2
                check bmp.TrafficMedium2
                check bmp.TrafficFree
                check bmp.TrafficFree
                check bmp.TMCTrafficProblem
                check bmp.TMCTrafficProblem
                check bmp.TMCAccident
                check bmp.TMCAccident
                check bmp.TMCClosure
                check bmp.TMCTunelBlocked
                check bmp.TMCAdditionalInfo
                check bmp.TMCAdditionalInfo
                check bmp.TMCLaneClosure
                check bmp.TMCRoadWorks
                check bmp.TMCObstacle
                check bmp.TMCRoadConditions
                check bmp.TMCWeather
                check bmp.TMCWind
                check bmp.TMCVisibility
                check bmp.TMCWeather
                check bmp.TMCActivity
                check bmp.TMCDelay
                check bmp.TMCDangerousVehicle
                check bmp.TMCExceptionalLoad
                check bmp.TMCTrafficEquipment
                check bmp.TMCSizeAndWeightLimits
                check bmp.TMCParkingRestrictions
                check bmp.TMCAdditionalInfo
                check bmp.TMCAdditionalInfo
                check bmp.TrafficClosed
                check bmp.TrafficBlocked
                check bmp.TrafficSlow
                check bmp.TrafficMedium1
                check bmp.TrafficMedium2
                check bmp.TrafficFree
                check traffic701
                check traffic72
                check traffic500
                check traffic71
                check traffic74
                check traffic73
                check traffic641
                check traffic513
                check traffic803
                check traffic514
                check traffic735
                check traffic703
                check traffic401
                check traffic707
                check traffic75
                check traffic922
                check traffic704
                check traffic76
                check traffic802
                check traffic517
                check traffic743
                check traffic133
                check traffic740
                check traffic501
                check traffic742
                check traffic739
                check traffic736
                check traffic808
                check traffic1205
                check traffic1802
                check traffic70
                check traffic503
                check traffic744
                check traffic738
                check traffic1854
                check traffic201
                check traffic515
                check traffic493
                check traffic938
                check traffic214
                check traffic810
                check traffic408
                check traffic804
                check traffic708
                check traffic746
                check traffic406
                check traffic469
                check traffic407
                check traffic1477
                check traffic709
                check traffic811
                check traffic478
                check traffic775
                check traffic409
                check error.compute.csEDiscontinuousNetwork
                check error.compute.csEUserCanceled
                check error.compute.csELowMemory
                check error.compute.csERoadsLimitReached
                check error.compute.csEFrontEmpty
                check error.compute.csEOptLogicInitFailed
                check error.compute.csEReconstructRouteFailed
                check error.compute.csEWrongFromPoint
                check error.compute.csEoutofmap
                check error.compute.csEFrontEmpty
                check routesummary.1Alternative
                check routesummary.2Alternative
                check routesummary.3Alternative
                check m
                check km
                check ft
                check mi
                check yd
                check signal.0
                check signal.1
                check signal.2
                check signal.3
                check signal.4
                check infobox.elevation
                check infobox.avgSpeed
                check infobox.eta
                check infobox.remainDist
                check infobox.totalDist
                check infobox.passed
                check infobox.signalLevel
                check infobox.speed
                check infobox.time
                check infobox.remainTime
                check timeSeconds
                check timeSecond
                check timeMinutes
                check timeMinute
                check timeHours
                check timeHour
                check SpeedCamera
                check RedLightCamera
                check MobileSpeedCamera
                check AvgSpeedCamera
                check MobileSpeedCamera
                check RedLightAndSpeedCamera
                check RedLightCamera
                check MobileAvgSpeedCamera
                check report.incident.police
                check SpeedCamera
                check report.incident.accident
                check eport.incident.traffic
                check Weight check
                check Distance check
                check report.incident.closure
                check report.incident.schoolZone

                searchTerm="id=\"hierarchy.iso."
                found=$(grep $searchTerm $entry | wc -l)
                if [ "$found" -lt 372 ];
                then
                  missing+=("hierarchy.iso.")
                  echo Missing: "hierarchy.iso."
                else
                  echo $searchTerm >> temporary
                fi

                checked="1"
              fi
            fi
          fi
        fi
      fi
      IFS=$'\n'
    done
    echo Missing ${#missing[@]}

    #search IDs that are not in lang files
    if [ $check -eq 0 ];
    then
      grep -v -f temporary $entry >> newFile
      grep "<lang id=" newFile >> del
      if [[ $arg == "-d" ]] || [[ $argv == "-d" ]];
      then
        grep -v -f del $entry >> dele
        rm $entry
        cat dele >> $entry
        rm dele
        echo Deleted $(cat del | wc -l)
      else
        echo Remove these lines from $entry
        cat del
        echo Over $(cat del | wc -l)
      fi

      rm newFile
      rm del
    else
      echo " "
      echo !!!The langCheck \for lang IDs that are not \in the source files will be available after you enter the "Check" files \in exceptions \in this script
    fi
    rm temporary
  fi
done
